Code

git-merge: add --ff and --no-ff options
[git.git] / git-merge.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 USAGE='[-n] [--summary] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s <strategy>] [-m=<merge-message>] <commit>+'
8 SUBDIRECTORY_OK=Yes
9 . git-sh-setup
10 require_work_tree
11 cd_to_toplevel
13 test -z "$(git ls-files -u)" ||
14         die "You are in the middle of a conflicted merge."
16 LF='
17 '
19 all_strategies='recur recursive octopus resolve stupid ours subtree'
20 default_twohead_strategies='recursive'
21 default_octopus_strategies='octopus'
22 no_fast_forward_strategies='subtree ours'
23 no_trivial_strategies='recursive recur subtree ours'
24 use_strategies=
26 allow_fast_forward=t
27 allow_trivial_merge=t
29 dropsave() {
30         rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
31                  "$GIT_DIR/MERGE_SAVE" || exit 1
32 }
34 savestate() {
35         # Stash away any local modifications.
36         git diff-index -z --name-only $head |
37         cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
38 }
40 restorestate() {
41         if test -f "$GIT_DIR/MERGE_SAVE"
42         then
43                 git reset --hard $head >/dev/null
44                 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
45                 git update-index --refresh >/dev/null
46         fi
47 }
49 finish_up_to_date () {
50         case "$squash" in
51         t)
52                 echo "$1 (nothing to squash)" ;;
53         '')
54                 echo "$1" ;;
55         esac
56         dropsave
57 }
59 squash_message () {
60         echo Squashed commit of the following:
61         echo
62         git log --no-merges ^"$head" $remoteheads
63 }
65 finish () {
66         if test '' = "$2"
67         then
68                 rlogm="$GIT_REFLOG_ACTION"
69         else
70                 echo "$2"
71                 rlogm="$GIT_REFLOG_ACTION: $2"
72         fi
73         case "$squash" in
74         t)
75                 echo "Squash commit -- not updating HEAD"
76                 squash_message >"$GIT_DIR/SQUASH_MSG"
77                 ;;
78         '')
79                 case "$merge_msg" in
80                 '')
81                         echo "No merge message -- not updating HEAD"
82                         ;;
83                 *)
84                         git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
85                         ;;
86                 esac
87                 ;;
88         esac
89         case "$1" in
90         '')
91                 ;;
92         ?*)
93                 if test "$show_diffstat" = t
94                 then
95                         # We want color (if set), but no pager
96                         GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
97                 fi
98                 ;;
99         esac
102 merge_name () {
103         remote="$1"
104         rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
105         bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
106         if test "$rh" = "$bh"
107         then
108                 echo "$rh               branch '$remote' of ."
109         elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
110                 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
111         then
112                 echo "$rh               branch '$truname' (early part) of ."
113         elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
114         then
115                 sed -e 's/      not-for-merge   /               /' -e 1q \
116                         "$GIT_DIR/FETCH_HEAD"
117         else
118                 echo "$rh               commit '$remote'"
119         fi
122 parse_option () {
123         case "$1" in
124         -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
125                 --no-summa|--no-summar|--no-summary)
126                 show_diffstat=false ;;
127         --summary)
128                 show_diffstat=t ;;
129         --sq|--squ|--squa|--squas|--squash)
130                 allow_fast_forward=t squash=t no_commit=t ;;
131         --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
132                 allow_fast_forward=t squash= no_commit= ;;
133         --c|--co|--com|--comm|--commi|--commit)
134                 allow_fast_forward=t squash= no_commit= ;;
135         --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
136                 allow_fast_forward=t squash= no_commit=t ;;
137         --ff)
138                 allow_fast_forward=t squash= no_commit= ;;
139         --no-ff)
140                 allow_fast_forward=false squash= no_commit= ;;
141         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
142                 --strateg=*|--strategy=*|\
143         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
144                 case "$#,$1" in
145                 *,*=*)
146                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
147                 1,*)
148                         usage ;;
149                 *)
150                         strategy="$2"
151                         shift ;;
152                 esac
153                 case " $all_strategies " in
154                 *" $strategy "*)
155                         use_strategies="$use_strategies$strategy " ;;
156                 *)
157                         die "available strategies are: $all_strategies" ;;
158                 esac
159                 ;;
160         -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
161                 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
162                 have_message=t
163                 ;;
164         -m|--m|--me|--mes|--mess|--messa|--messag|--message)
165                 shift
166                 case "$#" in
167                 1)      usage ;;
168                 esac
169                 merge_msg="$1"
170                 have_message=t
171                 ;;
172         -*)     usage ;;
173         *)      return 1 ;;
174         esac
175         shift
176         args_left=$#
179 parse_config () {
180         while test $# -gt 0
181         do
182                 parse_option "$@" || usage
183                 while test $args_left -lt $#
184                 do
185                         shift
186                 done
187         done
190 test $# != 0 || usage
192 have_message=
194 if branch=$(git-symbolic-ref -q HEAD)
195 then
196         mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
197         if test -n "$mergeopts"
198         then
199                 parse_config $mergeopts
200         fi
201 fi
203 while parse_option "$@"
204 do
205         while test $args_left -lt $#
206         do
207                 shift
208         done
209 done
211 if test -z "$show_diffstat"; then
212     test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
213     test -z "$show_diffstat" && show_diffstat=t
214 fi
216 # This could be traditional "merge <msg> HEAD <commit>..."  and the
217 # way we can tell it is to see if the second token is HEAD, but some
218 # people might have misused the interface and used a committish that
219 # is the same as HEAD there instead.  Traditional format never would
220 # have "-m" so it is an additional safety measure to check for it.
222 if test -z "$have_message" &&
223         second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
224         head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
225         test "$second_token" = "$head_commit"
226 then
227         merge_msg="$1"
228         shift
229         head_arg="$1"
230         shift
231 elif ! git rev-parse --verify HEAD >/dev/null 2>&1
232 then
233         # If the merged head is a valid one there is no reason to
234         # forbid "git merge" into a branch yet to be born.  We do
235         # the same for "git pull".
236         if test 1 -ne $#
237         then
238                 echo >&2 "Can merge only exactly one commit into empty head"
239                 exit 1
240         fi
242         rh=$(git rev-parse --verify "$1^0") ||
243                 die "$1 - not something we can merge"
245         git update-ref -m "initial pull" HEAD "$rh" "" &&
246         git read-tree --reset -u HEAD
247         exit
249 else
250         # We are invoked directly as the first-class UI.
251         head_arg=HEAD
253         # All the rest are the commits being merged; prepare
254         # the standard merge summary message to be appended to
255         # the given message.  If remote is invalid we will die
256         # later in the common codepath so we discard the error
257         # in this loop.
258         merge_name=$(for remote
259                 do
260                         merge_name "$remote"
261                 done | git fmt-merge-msg
262         )
263         merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
264 fi
265 head=$(git rev-parse --verify "$head_arg"^0) || usage
267 # All the rest are remote heads
268 test "$#" = 0 && usage ;# we need at least one remote head.
269 set_reflog_action "merge $*"
271 remoteheads=
272 for remote
273 do
274         remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
275             die "$remote - not something we can merge"
276         remoteheads="${remoteheads}$remotehead "
277         eval GITHEAD_$remotehead='"$remote"'
278         export GITHEAD_$remotehead
279 done
280 set x $remoteheads ; shift
282 case "$use_strategies" in
283 '')
284         case "$#" in
285         1)
286                 var="`git config --get pull.twohead`"
287                 if test -n "$var"
288                 then
289                         use_strategies="$var"
290                 else
291                         use_strategies="$default_twohead_strategies"
292                 fi ;;
293         *)
294                 var="`git config --get pull.octopus`"
295                 if test -n "$var"
296                 then
297                         use_strategies="$var"
298                 else
299                         use_strategies="$default_octopus_strategies"
300                 fi ;;
301         esac
302         ;;
303 esac
305 for s in $use_strategies
306 do
307         for ss in $no_fast_forward_strategies
308         do
309                 case " $s " in
310                 *" $ss "*)
311                         allow_fast_forward=f
312                         break
313                         ;;
314                 esac
315         done
316         for ss in $no_trivial_strategies
317         do
318                 case " $s " in
319                 *" $ss "*)
320                         allow_trivial_merge=f
321                         break
322                         ;;
323                 esac
324         done
325 done
327 case "$#" in
328 1)
329         common=$(git merge-base --all $head "$@")
330         ;;
331 *)
332         common=$(git show-branch --merge-base $head "$@")
333         ;;
334 esac
335 echo "$head" >"$GIT_DIR/ORIG_HEAD"
337 case "$allow_fast_forward,$#,$common,$no_commit" in
338 ?,*,'',*)
339         # No common ancestors found. We need a real merge.
340         ;;
341 ?,1,"$1",*)
342         # If head can reach all the merge then we are up to date.
343         # but first the most common case of merging one remote.
344         finish_up_to_date "Already up-to-date."
345         exit 0
346         ;;
347 t,1,"$head",*)
348         # Again the most common case of merging one remote.
349         echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
350         git update-index --refresh 2>/dev/null
351         msg="Fast forward"
352         if test -n "$have_message"
353         then
354                 msg="$msg (no commit created; -m option ignored)"
355         fi
356         new_head=$(git rev-parse --verify "$1^0") &&
357         git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
358         finish "$new_head" "$msg" || exit
359         dropsave
360         exit 0
361         ;;
362 ?,1,?*"$LF"?*,*)
363         # We are not doing octopus and not fast forward.  Need a
364         # real merge.
365         ;;
366 ?,1,*,)
367         # We are not doing octopus, not fast forward, and have only
368         # one common.
369         git update-index --refresh 2>/dev/null
370         case "$allow_trivial_merge" in
371         t)
372                 # See if it is really trivial.
373                 git var GIT_COMMITTER_IDENT >/dev/null || exit
374                 echo "Trying really trivial in-index merge..."
375                 if git read-tree --trivial -m -u -v $common $head "$1" &&
376                    result_tree=$(git write-tree)
377                 then
378                         echo "Wonderful."
379                         result_commit=$(
380                                 printf '%s\n' "$merge_msg" |
381                                 git commit-tree $result_tree -p HEAD -p "$1"
382                         ) || exit
383                         finish "$result_commit" "In-index merge"
384                         dropsave
385                         exit 0
386                 fi
387                 echo "Nope."
388         esac
389         ;;
390 *)
391         # An octopus.  If we can reach all the remote we are up to date.
392         up_to_date=t
393         for remote
394         do
395                 common_one=$(git merge-base --all $head $remote)
396                 if test "$common_one" != "$remote"
397                 then
398                         up_to_date=f
399                         break
400                 fi
401         done
402         if test "$up_to_date" = t
403         then
404                 finish_up_to_date "Already up-to-date. Yeeah!"
405                 exit 0
406         fi
407         ;;
408 esac
410 # We are going to make a new commit.
411 git var GIT_COMMITTER_IDENT >/dev/null || exit
413 # At this point, we need a real merge.  No matter what strategy
414 # we use, it would operate on the index, possibly affecting the
415 # working tree, and when resolved cleanly, have the desired tree
416 # in the index -- this means that the index must be in sync with
417 # the $head commit.  The strategies are responsible to ensure this.
419 case "$use_strategies" in
420 ?*' '?*)
421     # Stash away the local changes so that we can try more than one.
422     savestate
423     single_strategy=no
424     ;;
425 *)
426     rm -f "$GIT_DIR/MERGE_SAVE"
427     single_strategy=yes
428     ;;
429 esac
431 result_tree= best_cnt=-1 best_strategy= wt_strategy=
432 merge_was_ok=
433 for strategy in $use_strategies
434 do
435     test "$wt_strategy" = '' || {
436         echo "Rewinding the tree to pristine..."
437         restorestate
438     }
439     case "$single_strategy" in
440     no)
441         echo "Trying merge strategy $strategy..."
442         ;;
443     esac
445     # Remember which strategy left the state in the working tree
446     wt_strategy=$strategy
448     git-merge-$strategy $common -- "$head_arg" "$@"
449     exit=$?
450     if test "$no_commit" = t && test "$exit" = 0
451     then
452         merge_was_ok=t
453         exit=1 ;# pretend it left conflicts.
454     fi
456     test "$exit" = 0 || {
458         # The backend exits with 1 when conflicts are left to be resolved,
459         # with 2 when it does not handle the given merge at all.
461         if test "$exit" -eq 1
462         then
463             cnt=`{
464                 git diff-files --name-only
465                 git ls-files --unmerged
466             } | wc -l`
467             if test $best_cnt -le 0 -o $cnt -le $best_cnt
468             then
469                 best_strategy=$strategy
470                 best_cnt=$cnt
471             fi
472         fi
473         continue
474     }
476     # Automerge succeeded.
477     result_tree=$(git write-tree) && break
478 done
480 # If we have a resulting tree, that means the strategy module
481 # auto resolved the merge cleanly.
482 if test '' != "$result_tree"
483 then
484     if test "$allow_fast_forward" = "t"
485     then
486         parents=$(git show-branch --independent "$head" "$@")
487     else
488         parents=$(git rev-parse "$head" "$@")
489     fi
490     parents=$(echo "$parents" | sed -e 's/^/-p /')
491     result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
492     finish "$result_commit" "Merge made by $wt_strategy."
493     dropsave
494     exit 0
495 fi
497 # Pick the result from the best strategy and have the user fix it up.
498 case "$best_strategy" in
499 '')
500         restorestate
501         case "$use_strategies" in
502         ?*' '?*)
503                 echo >&2 "No merge strategy handled the merge."
504                 ;;
505         *)
506                 echo >&2 "Merge with strategy $use_strategies failed."
507                 ;;
508         esac
509         exit 2
510         ;;
511 "$wt_strategy")
512         # We already have its result in the working tree.
513         ;;
514 *)
515         echo "Rewinding the tree to pristine..."
516         restorestate
517         echo "Using the $best_strategy to prepare resolving by hand."
518         git-merge-$best_strategy $common -- "$head_arg" "$@"
519         ;;
520 esac
522 if test "$squash" = t
523 then
524         finish
525 else
526         for remote
527         do
528                 echo $remote
529         done >"$GIT_DIR/MERGE_HEAD"
530         printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
531 fi
533 if test "$merge_was_ok" = t
534 then
535         echo >&2 \
536         "Automatic merge went well; stopped before committing as requested"
537         exit 0
538 else
539         {
540             echo '
541 Conflicts:
543                 git ls-files --unmerged |
544                 sed -e 's/^[^   ]*      /       /' |
545                 uniq
546         } >>"$GIT_DIR/MERGE_MSG"
547         git rerere
548         die "Automatic merge failed; fix conflicts and then commit the result."
549 fi